package pps.core.base.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import pps.core.common.entity.BaseEnt;
import xstartup.annotation.XText;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * 市电峰谷策略
 *
 * @author ZWT
 * @date 2023/08/24
 */
@Data
@TableName("base_price_strategy")
public class BasePriceStrategyEnt extends BaseEnt implements Serializable {

    @XText("策略名称")
    @TableField
    private String policyName;

    @XText("适用地区编码")
    @TableField
    private Integer areaCode;

    @XText("年份")
    @TableField
    private String strategyYear;

    @XText("是否固定电价(0_是;1_否)")
    @TableField
    private Integer isFixedPrice;

    @XText("固定电价")
    @TableField
    private BigDecimal fixedElectricityPrice;
}
