package pps.core.space.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.space.entity.SpaceInstitutionWellheadEnt;
import pps.core.space.entity.SpaceInstitutionWellheadView;
import pps.core.space.mapper.SpaceInstitutionWellheadMapper;
import pps.core.space.mapper.SpaceInstitutionWellheadViewMapper;
import pps.core.space.service.data.space_institution_wellhead.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class SpaceInstitutionWellheadService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceInstitutionWellhead(XContext context, CreateSpaceInstitutionWellheadInput input) {
        SpaceInstitutionWellheadMapper mapper = context.getBean(SpaceInstitutionWellheadMapper.class);
        SpaceInstitutionWellheadEnt entity = new SpaceInstitutionWellheadEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceInstitutionWellhead(XContext context, UpdateSpaceInstitutionWellheadInput input) {
        SpaceInstitutionWellheadMapper mapper = context.getBean(SpaceInstitutionWellheadMapper.class);
        QueryWrapper<SpaceInstitutionWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionWellheadEnt::getId, input.getId());
        SpaceInstitutionWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceInstitutionWellhead(XContext context, DeleteSpaceInstitutionWellheadInput input) {
        SpaceInstitutionWellheadMapper mapper = context.getBean(SpaceInstitutionWellheadMapper.class);
        QueryWrapper<SpaceInstitutionWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionWellheadEnt::getId, input.getId());
        SpaceInstitutionWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceInstitutionWellheadOutput> getSpaceInstitutionWellhead(XContext context, GetSpaceInstitutionWellheadInput input) {
        SpaceInstitutionWellheadMapper mapper = context.getBean(SpaceInstitutionWellheadMapper.class);
        QueryWrapper<SpaceInstitutionWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionWellheadEnt::getId, input.getId());
        SpaceInstitutionWellheadEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceInstitutionWellheadOutput output = new GetSpaceInstitutionWellheadOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionWellheadOutput> querySpaceInstitutionWellhead(XContext context, QuerySpaceInstitutionWellheadInput input) {
        SpaceInstitutionWellheadMapper mapper = context.getBean(SpaceInstitutionWellheadMapper.class);
        QueryWrapper<SpaceInstitutionWellheadEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceInstitutionWellheadEnt::getId, input.getId())
                .eq(SpaceInstitutionWellheadEnt::getIsDeleted, input.getIsDeleted())
                .like(SpaceInstitutionWellheadEnt::getCreateById, input.getCreateById())
                .like(SpaceInstitutionWellheadEnt::getCreateByName, input.getCreateByName())
                .eq(SpaceInstitutionWellheadEnt::getCreateTime, input.getCreateTime())
                .like(SpaceInstitutionWellheadEnt::getModifyById, input.getModifyById())
                .like(SpaceInstitutionWellheadEnt::getModifyByName, input.getModifyByName())
                .eq(SpaceInstitutionWellheadEnt::getModifyTime, input.getModifyTime())
                .like(SpaceInstitutionWellheadEnt::getInstitutionId, input.getInstitutionId())
                .like(SpaceInstitutionWellheadEnt::getWellheadId, input.getWellheadId())
                .like(SpaceInstitutionWellheadEnt::getWellNumber, input.getWellNumber())
                .like(SpaceInstitutionWellheadEnt::getRunTypeKey, input.getRunTypeKey())
                .like(SpaceInstitutionWellheadEnt::getIntervalTypeKey, input.getIntervalTypeKey())
                .like(SpaceInstitutionWellheadEnt::getIntervalDescribe, input.getIntervalDescribe())
                .eq(SpaceInstitutionWellheadEnt::getStartSeq, input.getStartSeq())
                .eq(SpaceInstitutionWellheadEnt::getOpenWellDay, input.getOpenWellDay())
                .eq(SpaceInstitutionWellheadEnt::getCloseWellDay, input.getCloseWellDay())
                .eq(SpaceInstitutionWellheadEnt::getRunDuration, input.getRunDuration());
        return XMapperHelper.query(mapper, input, queryWrapper, QuerySpaceInstitutionWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionWellheadOutput> dynamicQuerySpaceInstitutionWellhead(XContext context, CustomQueryInput input) {
        SpaceInstitutionWellheadMapper mapper = context.getBean(SpaceInstitutionWellheadMapper.class);
        return XMapperHelper.query(mapper, input, SpaceInstitutionWellheadEnt.class, QuerySpaceInstitutionWellheadOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceInstitutionWellheadViewOutput> getSpaceInstitutionWellheadView(XContext context, GetSpaceInstitutionWellheadViewInput input) {
        SpaceInstitutionWellheadViewMapper mapper = context.getBean(SpaceInstitutionWellheadViewMapper.class);
        SpaceInstitutionWellheadView record = new SpaceInstitutionWellheadView();
        XCopyUtils.copyObject(input, record);
        SpaceInstitutionWellheadView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceInstitutionWellheadViewOutput output = new GetSpaceInstitutionWellheadViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionWellheadViewOutput> querySpaceInstitutionWellheadView(XContext context, QuerySpaceInstitutionWellheadViewInput input) {
        SpaceInstitutionWellheadViewMapper mapper = context.getBean(SpaceInstitutionWellheadViewMapper.class);
        SpaceInstitutionWellheadView record = new SpaceInstitutionWellheadView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceInstitutionWellheadView> list = mapper.selectList(record);
        PageInfo<SpaceInstitutionWellheadView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceInstitutionWellheadViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceInstitutionWellheadViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
